Index: /TOOLS/MOSAIX/CalvingWeights.py
===================================================================
--- /TOOLS/MOSAIX/CalvingWeights.py	(revision 6665)
+++ /TOOLS/MOSAIX/CalvingWeights.py	(revision 6666)
@@ -25,58 +25,100 @@
 ##  software by incorrectly or partially configured
 ##
-##
-import numpy as np, xarray as xr
-import sys, os, platform, argparse, textwrap, time
+'''Python code to generates weights for calving. Launched by `CreateWeights.bash`.
+
+More information with python `CalvingWeights.py -h`.
+
+- The atmosphere model integrate the calving over on specific
+  regions. Presently the regions are three latitudinal bands with
+  limits 90Â°S/40Â°S/50Â°N/90Â°N.
+
+- The weights distribute the calving in the ocean in the
+  corresponding latitudinal bands. By default, the distribution is
+  uniform.
+
+- For the southernmost band, it is possible to use a geographical
+  distribution read in a file. These files are currently available
+  for eORCA1 and eORCA025.
+
+## SVN information
+Author   = "$Author$"
+Date     = "$Date$"
+Revision = "$Revision$"
+Id       = "$Id$"
+HeadURL  = "$HeadURL$"
+'''
+import sys
+import os
+import getpass
+import platform
+import argparse
+import time
+import numpy as np
+import xarray as xr
 from scipy import ndimage
 import nemo
 
 ## SVN information
-__Author__   = "$Author$"
-__Date__     = "$Date$"
-__Revision__ = "$Revision$"
-__Id__       = "$Id$"
-__HeadURL__  = "$HeadURL$"
-__SVN_Date__ = "$SVN_Date: $"
-
+__SVN__ =  ( {
+    'Author'   : "$Author$",
+    'Date'     : '$Date$',
+    'Revision' : '$Revision$',
+    'Id'       : '$Id$',
+    'HeadURL'  : '$HeadURL$',
+    'SVN_Date' : '$SVN_Date: $',
+    } )
 ###
 
-### ===== Handling command line parameters ==================================================
+### ===== Handling command line parameters ==========================
 # Creating a parser
 parser = argparse.ArgumentParser (
-    description = """Compute calving weights""",
+    description = '''Compute calving weights''',
     epilog='-------- End of the help message --------')
 
 # Adding arguments
 parser.add_argument ('--oce'     , help='oce model name', type=str, default='eORCA1.2',
-                         choices=['ORCA2.3', 'ORCA1.0', 'ORCA1.1', 'ORCA1_CNRM', 'eORCA1.2', 'eORCA1.4', 'eORCA1.4.2', 'eORCA025', 'eORCA025.1', 'eORCA025.4'] )
-parser.add_argument ('--atm'     , help='atm model name (ICO* or LMD*)', type=str, default='ICO40'    )
-parser.add_argument ('--type'    , help='Type of distribution', type=str, choices=['iceshelf', 'iceberg', 'nosouth', 'full'], default='full'  )
+                      choices=['ORCA2.3', 'ORCA1.0', 'ORCA1.1', 'ORCA1_CNRM', 'eORCA1.2',
+                               'eORCA1.4', 'eORCA1.4.2', 'eORCA025', 'eORCA025.1', 'eORCA025.4'] )
+parser.add_argument ('--atm'     , type=str, default='ICO40',
+                         help='atm model name (ICO* or LMD*)' )
+parser.add_argument ('--type'    , help='Type of distribution', type=str,
+                         choices=['iceshelf', 'iceberg', 'nosouth', 'full'], default='full'  )
 ## parser.add_argument ('--dir'     , help='Directory of input file', type=str, default='./' )
-parser.add_argument ('--repartition_file', help='Data files with iceberg melting' , type=str, default='./runoff-icb_DaiTrenberth_Depoorter_eORCA1_JD.nc' )
-parser.add_argument ('--repartition_var' , help='Variable name for iceshelf'      , type=str, default=None)
+parser.add_argument ('--repartition_file', help='Data files with iceberg melting' , type=str,
+                         default='./runoff-icb_DaiTrenberth_Depoorter_eORCA1_JD.nc' )
+parser.add_argument ('--repartition_var' , type=str, default=None,
+                         help='Variable name for iceshelf' )
 parser.add_argument ('--grids' , help='grids file name', default='grids.nc' )
 parser.add_argument ('--areas' , help='masks file name', default='areas.nc' )
 parser.add_argument ('--masks' , help='areas file name', default='masks.nc' )
 parser.add_argument ('--o2a'   , help='o2a file name'  , default='o2a.nc'   )
-parser.add_argument ('--output'  , help='output rmp file name', default='rmp_tlmd_to_torc_calving.nc' )
-parser.add_argument ('--fmt'     , help='NetCDF file format, using nco syntax', default='netcdf4',
-                         choices=['classic', 'netcdf3', '64bit', '64bit_data', '64bit_data', 'netcdf4', 'netcdf4_classsic'] )
-parser.add_argument ('--ocePerio', help='periodicity of ocean grid', type=float, default=0, choices=nemo.nperio_valid_range )
+parser.add_argument ('--output', help='output rmp file name',
+                         default='rmp_tlmd_to_torc_calving.nc' )
+parser.add_argument ('--fmt' , default='netcdf4'    ,
+                         help='NetCDF file format, using nco syntax',
+                         choices=['classic', 'netcdf3', '64bit', '64bit_data',
+                                  '64bit_data', 'netcdf4', 'netcdf4_classsic'] )
+parser.add_argument ('--ocePerio', type=float, default=0, choices=nemo.NPERIO_VALID_RANGE,
+                         help='periodicity of ocean grid' )
+parser.add_argument ('--modelName'   , help='Name of model', type=str, default=None)
 
 # Parse command line
-myargs = parser.parse_args()
+myargs = parser.parse_args ()
 
 # Model Names
-src_Name = myargs.atm ; dst_Name = myargs.oce
-    
+src_Name   = myargs.atm
+dst_Name   = myargs.oce
+model_name = myargs.modelName
+
 # Default vars
-if myargs.repartition_var == None :
+if myargs.repartition_var is None :
     # Runoff from Antarctica iceshelves (Depoorter, 2013)
-    if myargs.type == 'iceshelf' : repartitionVar = 'sornfisf'
-        
+    if myargs.type == 'iceshelf' :
+        repartitionVar = 'sornfisf'
     # Runoff from Antarctica iceberg (Depoorter, 2013)
-    if myargs.type == 'iceberg' :  repartitionVar = 'Icb_Flux'
-        
-else :                             repartitionVar = myargs.repartition_var
+    if myargs.type == 'iceberg' :
+        repartitionVar = 'Icb_Flux'
+else :
+    repartitionVar = myargs.repartition_var
 
 # Latitude limits of each calving zone
@@ -92,8 +134,9 @@
 if myargs.fmt == 'netcdf4'         : FmtNetcdf = 'NETCDF4'
 if myargs.fmt == 'netcdf4_classic' : FmtNetcdf = 'NETCDF4_CLASSIC'
-### ==========================================================================================
+### =====================================================================
 
 # Model short names
-src_name = None ; dst_name = None
+src_name = None
+dst_name = None
 if src_Name.count('ICO')  != 0 : src_name = 'ico'
 if src_Name.count('LMD')  != 0 : src_name = 'lmd'
@@ -138,5 +181,5 @@
     if dst_Name in ['eORCA1.2', 'eORCA1.3']          : nperio_dst = 6
     if dst_Name in ['ORCA025', 'eORCA025', 'eORCA025.1', 'eORCA025.4'] : nperio_dst = 6
-        
+
 print ('nperio_dst: ' + str(nperio_dst) )
 dst_mskutil = nemo.lbc_mask (dst_mskutil, nperio=nperio_dst, cd_type='T', sval=0 )
@@ -161,5 +204,5 @@
     # Set Hudson Strait to 0 to fill Hudson Bay
     dst_mskutil[997:1012,907] = 0
-    
+
 if dst_Name in [ 'eORCA1.2', 'eORCA1.3', 'eORCA1.4', 'eORCA1.4.2' ] :
     print ('Filling some seas for ' + dst_Name)
@@ -174,5 +217,5 @@
     # Set Hudson Strait to 0 to fill Hudson Bay
     dst_mskutil[284,222:225] = 0
-    
+
 if dst_Name in [ 'ORCA2.3', 'ORCA2.4' ] :
     print ('Filling some seas for ' + dst_Name)
@@ -193,5 +236,7 @@
 # Fill closed seas with image processing library
 # ----------------------------------------------
-dst_mskutil = nemo.lbc_mask ( 1-ndimage.binary_fill_holes (1-nemo.lbc(dst_mskutil, nperio=nperio_dst, cd_type='T')), nperio=nperio_dst, cd_type='T', sval=0)
+dst_mskutil = nemo.lbc_mask ( 1-ndimage.binary_fill_holes (
+    1-nemo.lbc(dst_mskutil, nperio=nperio_dst, cd_type='T')),
+                              nperio=nperio_dst, cd_type='T', sval=0)
 
 # Surfaces
@@ -208,10 +253,12 @@
 
 # Indices
-( src_jpj, src_jpi) = src_lat.shape ; src_grid_size = src_jpj*src_jpi
-( dst_jpj, dst_jpi) = dst_lat.shape ; dst_grid_size = dst_jpj*dst_jpi
+( src_jpj, src_jpi) = src_lat.shape
+src_grid_size = src_jpj*src_jpi
+( dst_jpj, dst_jpi) = dst_lat.shape
+dst_grid_size = dst_jpj*dst_jpi
 orc_index = np.arange (dst_jpj*dst_jpi, dtype=np.int32) + 1 # Fortran indices (starting at one)
 
-### ===== Reading needed data ==================================================
-if myargs.type in ['iceberg', 'iceshelf' ]: 
+### ===== Reading needed data ========================================
+if myargs.type in ['iceberg', 'iceshelf' ]:
     # Reading data file for calving or iceberg geometry around Antarctica
     print ( 'Opening ' + myargs.repartition_file)
@@ -226,5 +273,5 @@
 print (' ')
 
-### ===== Starting loop on basins==============================================
+### ===== Starting loop on basins=====================================
 
 # Initialise some fields
@@ -238,42 +285,62 @@
 ## Loop
 for n_bas in np.arange ( nb_zone ) :
-    south = False ; ok_run = False
-    lat_south = np.min(limit_lat[n_bas]) ; lat_north = np.max(limit_lat[n_bas])
+    south  = False
+    ok_run = False
+    lat_south = np.min(limit_lat[n_bas])
+    lat_north = np.max(limit_lat[n_bas])
     if lat_south <= -60.0 : south = True
-    
-    print ( 'basin: {:2d} -- Latitudes: {:+.1f} {:+.1f} --'.format(n_bas, lat_south, lat_north) )
+
+    print ( f'basin: {n_bas:2d} -- Latitudes: {lat_south:+.1f} {lat_north:+.1f} --' )
     ##
-    if myargs.type == 'iceberg'  and     south : ok_run = True  ; print ('Applying iceberg to south' )
-    if myargs.type == 'iceshelf' and     south : ok_run = True  ; print ('Applying iceshelf to south' )
-    if myargs.type == 'iceberg'  and not south : ok_run = False ; print ('Skipping iceberg: not south ')
-    if myargs.type == 'iceshelf' and not south : ok_run = False ; print ('Skipping iceshelf: not south ')
-    if myargs.type == 'nosouth'  and     south : ok_run = False ; print ('Skipping south: nosouth case' )
-    if myargs.type == 'nosouth'  and not south : ok_run = True  ; print ('Running: not in south, uniform repartition')
-    if myargs.type == 'full'                   : ok_run = True  ; print ('Running general trivial case, uniform repartition' )
+    if myargs.type == 'iceberg'  and     south :
+        ok_run = True
+        print ('Applying iceberg to south' )
+    if myargs.type == 'iceshelf' and     south :
+        ok_run = True
+        print ('Applying iceshelf to south' )
+    if myargs.type == 'iceberg'  and not south :
+        ok_run = False
+        print ('Skipping iceberg: not south ')
+    if myargs.type == 'iceshelf' and not south :
+        ok_run = False
+        print ('Skipping iceshelf: not south ')
+    if myargs.type == 'nosouth'  and     south :
+        ok_run = False
+        print ('Skipping south: nosouth case' )
+    if myargs.type == 'nosouth'  and not south :
+        ok_run = True
+        print ('Running: not in south, uniform repartition')
+    if myargs.type == 'full' :
+        ok_run = True
+        print ('Running general trivial case, uniform repartition' )
 
     if ok_run :
         # Calving integral send to one point per latitude bands
         index_src = ((src_grid_size - 1)*n_bas) // (nb_zone-1) + 1
-   
+
         # Basin mask
-        basin_msk[n_bas] = np.where ( (dst_lat > lat_south ) & (dst_lat <= lat_north ), dst_mskutil, 0 )
+        basin_msk[n_bas] = np.where ( (dst_lat > lat_south ) & (dst_lat <= lat_north ),
+                                          dst_mskutil, 0 )
 
         # Repartition pattern
-        if myargs.type in ['iceberg', 'iceshelf' ] : key_repartition[n_bas] = repartition * basin_msk[n_bas]
-        else :                                       key_repartition[n_bas] =               basin_msk[n_bas]
+        if myargs.type in ['iceberg', 'iceshelf' ] :
+            key_repartition[n_bas] = repartition * basin_msk[n_bas]
+        else :
+            key_repartition[n_bas] =               basin_msk[n_bas]
 
         # Integral and normalisation
         sum_repartition = np.sum ( key_repartition[n_bas] * dst_srfutil ).values
         key_repartition = key_repartition / sum_repartition
-    
+
         print ( 'Sum of repartition key                      : {:12.3e}'.format (np.sum (key_repartition[n_bas]               )) )
         print ( 'Integral (area weighted) of repartition key : {:12.3e}'.format (np.sum (key_repartition[n_bas] * dst_srfutil ).values) )
-    
+
         # Basin surface (modulated by repartition key)
         basin_srfutil = np.sum ( key_repartition[n_bas] * dst_srfutil )
-            
+
         # Weights and links
         poids = 1.0 / basin_srfutil
-        matrix_local   = np.where ( basin_msk[n_bas].ravel() > 0.5, key_repartition[n_bas].ravel()*poids.values, 0. )
+        matrix_local   = np.where ( basin_msk[n_bas].ravel() > 0.5,
+                                        key_repartition[n_bas].ravel()*poids.values, 0. )
         matrix_local   = matrix_local[matrix_local > 0.0] # Keep only non zero values
         num_links      = np.count_nonzero (matrix_local)
@@ -289,18 +356,16 @@
         #
         #print ( 'Sum of remap_matrix : {:12.3e}'.format(np.sum(matrix_local)) )
-        print ( 'Point in atmospheric grid : {:4d} -- num_links: {:6d}'.format(index_src, num_links) ) 
+        print ( 'Point in atmospheric grid : {index_src:4d} -- num_links: {num_links:6d}' )
         print ('  ')
-
-
 
 ## End of loop
 print (' ')
 
-# 
+#
 num_links = np.count_nonzero (remap_matrix)
-print ( 'Total num_links : {:10d}'.format(num_links) )
+print ( f'Total num_links : {num_links:10d}' )
 
 # Diag : interpolate uniform field
-src_field = np.zeros(shape=(src_grid_size))
+src_field = np.zeros(shape=(src_grid_size,))
 for n_bas in np.arange ( nb_zone ) :
     index_src = ((src_grid_size - 1)*n_bas) // (nb_zone-1) + 1
@@ -311,78 +376,105 @@
     dst_field [dst_address [link]-1] +=  remap_matrix[link] * src_field[src_address[link]-1]
 
-### ===== Writing the weights file, for OASIS MCT ==========================================
+### ===== Writing the weights file, for OASIS MCT =======================
 
 # Output file
 calving = myargs.output
-    
+
 print ('Output file: ' + calving )
 
-remap_matrix = xr.DataArray (np.reshape(remap_matrix, (num_links, 1)), dims = ['num_links', 'num_wgts'] )
-src_address  = xr.DataArray (src_address.astype(np.int32) , dims = ['num_links',] )
-src_address.attrs['convention'] = "Fortran style addressing, starting at 1"
-dst_address  = xr.DataArray (dst_address.astype(np.int32) , dims =  ['num_links',] )
-dst_address.attrs['convention'] = "Fortran style addressing, starting at 1"
-
-src_grid_dims       = xr.DataArray ( np.array (( src_jpi, src_jpi ), dtype=np.int32), dims =  ['src_grid_rank',] )
+remap_matrix = xr.DataArray (np.reshape(remap_matrix, (num_links, 1)),
+                                 dims = ['num_links', 'num_wgts'] )
+src_address  = xr.DataArray (src_address.astype(np.int32) ,
+                                 dims = ['num_links',] )
+src_address.attrs['convention'] = 'Fortran style addressing, starting at 1'
+dst_address  = xr.DataArray (dst_address.astype(np.int32) ,
+                                 dims =  ['num_links',] )
+dst_address.attrs['convention'] = 'Fortran style addressing, starting at 1'
+
+src_grid_dims       = xr.DataArray ( np.array (( src_jpi, src_jpi ), dtype=np.int32),
+                                         dims =  ['src_grid_rank',] )
 src_grid_center_lon = xr.DataArray ( src_lon.values.ravel(), dims = ['src_grid_size',] )
 src_grid_center_lat = xr.DataArray ( src_lat.values.ravel(), dims = ['src_grid_size',] )
-src_grid_center_lon.attrs['units']='degrees_east'  ; src_grid_center_lon.attrs['long_name']='Longitude'
-src_grid_center_lon.attrs['long_name']='longitude' ; src_grid_center_lon.attrs['bounds']="src_grid_corner_lon" 
-src_grid_center_lat.attrs['units']='degrees_north' ; src_grid_center_lat.attrs['long_name']='Latitude'
-src_grid_center_lat.attrs['long_name']='latitude ' ; src_grid_center_lat.attrs['bounds']="src_grid_corner_lat" 
-src_grid_corner_lon = xr.DataArray ( src_clo.values.reshape( (src_jpi*src_jpj, src_clo.shape[0]) ), dims = ['src_grid_size', 'src_grid_corners'] )
-src_grid_corner_lat = xr.DataArray ( src_cla.values.reshape( (src_jpi*src_jpj, src_clo.shape[0]) ), dims = ['src_grid_size', 'src_grid_corners' ] )
-src_grid_corner_lon.attrs['units']="degrees_east"
-src_grid_corner_lat.attrs['units']="degrees_north"
+src_grid_center_lon.attrs.update ( {'units':'degrees_east ', 'long_name':'Longitude',
+                                        'standard_name':'longitude',
+                                        'bounds':'src_grid_corner_lon'})
+src_grid_center_lat.attrs.update ( {'units':'degrees_north', 'long_name':'Latitude' ,
+                                        'standard_name':'latitude' ,
+                                        'bounds':'src_grid_corner_lat'})
+src_grid_corner_lon = xr.DataArray ( src_clo.values.reshape( (src_jpi*src_jpj, src_clo.shape[0]) ),
+                                         dims = ['src_grid_size', 'src_grid_corners'] )
+src_grid_corner_lat = xr.DataArray ( src_cla.values.reshape( (src_jpi*src_jpj, src_clo.shape[0]) ),
+                                         dims = ['src_grid_size', 'src_grid_corners' ] )
+src_grid_corner_lon.attrs['units']='degrees_east'
+src_grid_corner_lat.attrs['units']='degrees_north'
 src_grid_area       = xr.DataArray ( src_srf.values.ravel(), dims = ['src_grid_size',] )
-src_grid_area.attrs['long_name']="Grid area" ; src_grid_area.attrs['standard_name']="cell_area" ; src_grid_area.attrs['units']="m2"
-src_grid_imask      = xr.DataArray ( src_msk.values.ravel().astype(np.int32) , dims = ['src_grid_size',] )
-src_grid_imask.attrs['long_name']="Land-sea mask" ; src_grid_imask.attrs['units']="Land:1, Ocean:0"
+src_grid_area.attrs.update ({'long_name':'Grid area', 'standard_name':'cell_area', 'units':'m2'})
+src_grid_imask      = xr.DataArray ( src_msk.values.ravel().astype(np.int32) ,
+                                         dims = ['src_grid_size',] )
+src_grid_imask.attrs.update ( {'long_name':'-sea mask', 'units':'Land:1, Ocean:0' })
 
 # --
-dst_grid_dims       = xr.DataArray ( np.array(( dst_jpi, dst_jpi), dtype=np.int32) , dims = ['dst_grid_rank', ])
+dst_grid_dims       = xr.DataArray ( np.array(( dst_jpi, dst_jpi), dtype=np.int32) ,
+                                         dims = ['dst_grid_rank', ])
 dst_grid_center_lon = xr.DataArray ( dst_lon.values.ravel(), dims = ['dst_grid_size', ])
 dst_grid_center_lat = xr.DataArray ( dst_lat.values.ravel(), dims = ['dst_grid_size', ])
-dst_grid_center_lon.attrs['units']='degrees_east'  ; dst_grid_center_lon.attrs['long_name']='Longitude'
-dst_grid_center_lon.attrs['long_name']='longitude' ; dst_grid_center_lon.attrs['bounds']="dst_grid_corner_lon" 
-dst_grid_center_lat.attrs['units']='degrees_north' ; dst_grid_center_lat.attrs['long_name']='Latitude'
-dst_grid_center_lat.attrs['long_name']='latitude'  ; dst_grid_center_lat.attrs['bounds']="dst_grid_corner_lat" 
-dst_grid_corner_lon = xr.DataArray ( dst_clo.values.reshape(dst_jpi*dst_jpj, dst_clo.shape[0] ), dims = ['dst_grid_size', 'dst_grid_corners'] )
-dst_grid_corner_lat = xr.DataArray ( dst_cla.values.reshape(dst_jpi*dst_jpj, dst_clo.shape[0] ), dims = ['dst_grid_size', 'dst_grid_corners'] )
-dst_grid_corner_lon.attrs['units']="degrees_east"
-dst_grid_corner_lat.attrs['units']="degrees_north"
+dst_grid_center_lon.attrs.update ( {'units':'degrees_east ', 'long_name':'Longitude',
+                                        'standard_name':'longitude',
+                                        'bounds':'dst_grid_corner_lon'})
+dst_grid_center_lat.attrs.update ( {'units':'degrees_north', 'long_name':'Latitude' ,
+                                        'standard_name':'latitude' ,
+                                        'bounds':'dst_grid_corner_lat'})
+dst_grid_corner_lon = xr.DataArray ( dst_clo.values.reshape(dst_jpi*dst_jpj, dst_clo.shape[0] ),
+                                         dims = ['dst_grid_size', 'dst_grid_corners'] )
+dst_grid_corner_lat = xr.DataArray ( dst_cla.values.reshape(dst_jpi*dst_jpj, dst_clo.shape[0] ),
+                                         dims = ['dst_grid_size', 'dst_grid_corners'] )
+dst_grid_corner_lon.attrs['units']='degrees_east'
+dst_grid_corner_lat.attrs['units']='degrees_north'
 dst_grid_area       = xr.DataArray ( dst_srf.values.ravel(), dims = ['dst_grid_size', ] )
-dst_grid_area.attrs['long_name']="Grid area" ; dst_grid_area.attrs['standard_name']="cell_area" ; dst_grid_area.attrs['units']="m2"
+dst_grid_area.attrs.update ({'long_name':'Grid area', 'standard_name':'cell_area', 'units':'m2'})
 dst_grid_imask      = xr.DataArray ( dst_msk.values.ravel(), dims =  ['dst_grid_size',]  )
-dst_grid_imask.attrs['long_name']="Land-sea mask" ; dst_grid_imask.attrs['units']="Land:1, Ocean:0"
-
-dst_bassin      = xr.DataArray ( basin_msk.reshape ( (nb_zone,dst_grid_size) ) , dims = ['nb_zone', 'dst_grid_size',  ] )
-dst_repartition = xr.DataArray ( key_repartition.reshape( (nb_zone,dst_grid_size) ) , dims = ['nb_zone', 'dst_grid_size',  ] )
-
-dst_southLimit = xr.DataArray ( np.min(limit_lat, axis=(1,)).astype(np.float32) , dims = ['nb_zone', ] )
-dst_northLimit = xr.DataArray ( np.min(limit_lat, axis=(1,)).astype(np.float32) , dims = ['nb_zone', ] )
+dst_grid_imask.attrs.update ( {'long_name':'Land-sea mask', 'units':'Land:1, Ocean:0' } )
+
+dst_bassin      = xr.DataArray ( basin_msk.reshape ( (nb_zone,dst_grid_size) ) ,
+                                     dims = ['nb_zone', 'dst_grid_size',  ] )
+dst_repartition = xr.DataArray ( key_repartition.reshape( (nb_zone,dst_grid_size) ) ,
+                                     dims = ['nb_zone', 'dst_grid_size',  ] )
+
+dst_southLimit = xr.DataArray ( np.min(limit_lat, axis=(1,)).astype(np.float32) ,
+                                    dims = ['nb_zone', ] )
+dst_northLimit = xr.DataArray ( np.min(limit_lat, axis=(1,)).astype(np.float32) ,
+                                    dims = ['nb_zone', ] )
 
 # Additionnal fields for debugging
 # ================================
-dst_grid_imaskutil  = xr.DataArray ( dst_mskutil.ravel().astype(np.float32), dims = ['dst_grid_size',] )
-dst_grid_imaskutil.attrs['long_name']="Land-sea mask" ; dst_grid_imaskutil.attrs['units']="Land:1, Ocean:0"
+dst_grid_imaskutil  = xr.DataArray ( dst_mskutil.ravel().astype(np.float32),
+                                         dims = ['dst_grid_size',] )
+dst_grid_imaskutil.attrs.update ( {'long_name':'Land-sea mask', 'units':'Land:1, Ocean:0' })
 dst_grid_imaskclose = xr.DataArray ( dst_closed.values.ravel(), dims = ['dst_grid_size',] )
-dst_grid_imaskclose.attrs['long_name']="Land-sea mask" ; dst_grid_imaskclose.attrs['units']="Land:1, Ocean:0"
-
-dst_lon_addressed = xr.DataArray ( dst_lon.values.ravel()[dst_address-1].ravel(), dims = ['num_links',] )
-dst_lat_addressed = xr.DataArray ( dst_lat.values.ravel()[dst_address-1].ravel(), dims = ['num_links',] )
-dst_lon_addressed.attrs['long_name']="Longitude" ; dst_lon_addressed.attrs['standard_name']="longitude" ; dst_lon_addressed.attrs['units']="degrees_east"
-dst_lat_addressed.attrs['long_name']="Latitude"  ; dst_lat_addressed.attrs['standard_name']="latitude"  ; dst_lat_addressed.attrs['units']="degrees_north"
-dst_area_addressed  = xr.DataArray ( dst_srf.values.ravel()[dst_address-1].ravel(), dims = ['num_links',] )
-dst_area_addressed.attrs['long_name']="Grid area" ; dst_area_addressed.attrs['standard_name']="cell_area" ; dst_grid_area.attrs['units']="m2"
-dst_imask_addressed = xr.DataArray ( dst_msk.values.ravel()[dst_address-1].ravel(), dims = ['num_links', ] )
-dst_imask_addressed.attrs['long_name']="Land-sea mask" ; dst_imask_addressed.attrs['units']="Land:1, Ocean:0"
-dst_imaskutil_addressed = xr.DataArray ( dst_mskutil.ravel()[dst_address-1].astype(np.float32), dims = ['num_links'] )
-dst_imaskutil_addressed.attrs['long_name']="Land-sea mask" ; dst_imaskutil_addressed.attrs['units']="Land:1, Ocean:0"
+dst_grid_imaskclose.attrs.update ({'long_name':'Land-sea mask', 'units':'Land:1, Ocean:0' })
+
+dst_lon_addressed = xr.DataArray ( dst_lon.values.ravel()[dst_address-1].ravel(),
+                                       dims = ['num_links',] )
+dst_lat_addressed = xr.DataArray ( dst_lat.values.ravel()[dst_address-1].ravel(),
+                                       dims = ['num_links',] )
+dst_lon_addressed.attrs.update ( {'units':'degrees_east ', 'long_name':'Longitude',
+                                      'standard_name':'longitude' })
+dst_lat_addressed.attrs.update ( {'units':'degrees_north', 'long_name':'Latitude' ,
+                                      'standard_name':'latitude'  })
+dst_area_addressed  = xr.DataArray ( dst_srf.values.ravel()[dst_address-1].ravel(),
+                                         dims = ['num_links',] )
+dst_area_addressed.attrs.update ( {'long_name':'Grid area0', 'standard_name':'cell_area',
+                                       'units':'m2' })
+dst_imask_addressed = xr.DataArray ( dst_msk.values.ravel()[dst_address-1].ravel(),
+                                         dims = ['num_links', ] )
+dst_imask_addressed.attrs.update ( {'long_name':'Land-sea mask', 'units':'Land:1, Ocean:0' })
+dst_imaskutil_addressed = xr.DataArray ( dst_mskutil.ravel()[dst_address-1].astype(np.float32),
+                                             dims = ['num_links'] )
+dst_imaskutil_addressed.attrs.update ( {'long_name':'Land-sea mask', 'units':'Land:1, Ocean:0' })
 
 src_field = xr.DataArray ( src_field, dims = ['src_grid_size',] )
 dst_field = xr.DataArray ( dst_field, dims = ['dst_grid_size',] )
 
-f_calving =  xr.Dataset ( { 
+f_calving =  xr.Dataset ( {
     'remap_matrix'            : remap_matrix,
 	'src_address'             : src_address,
@@ -417,49 +509,43 @@
     } )
 
-f_calving.attrs['Conventions']     = "CF-1.6"
-f_calving.attrs['source']          = "IPSL Earth system model"
-f_calving.attrs['group']           = "ICMC IPSL Climate Modelling Center"
-f_calving.attrs['Institution']     = "IPSL https.//www.ipsl.fr"
-f_calving.attrs['Ocean']           = dst_Name + " https://www.nemo-ocean.eu"
-f_calving.attrs['Atmosphere']      = src_Name + " http://lmdz.lmd.jussieu.fr"
-if myargs.type in ['iceberg', 'iceshelf' ]: f_calving.attrs['originalFiles'] = myargs.repartition_file
-f_calving.attrs['associatedFiles'] = grids + " " + areas + " " + masks
-
-f_calving.attrs['description']     = "Generated with XIOS http://forge.ipsl.jussieu.fr/ioserver and MOSAIX https://forge.ipsl.jussieu.fr/igcmg/browser/TOOLS/MOSAIX"
-f_calving.attrs['title']           = calving
-f_calving.attrs['Program']         = "Generated by " + sys.argv[0] + " with flags " + ' '.join (sys.argv[1:]) 
-
-f_calving.attrs['repartitionType'] = myargs.type
+f_calving.attrs.update ( {
+    'Conventions'     : 'CF-1.6',
+    'source'          : 'IPSL Earth system model',
+    'group'           : 'ICMC IPSL Climate Modelling Center',
+    'Institution'     : 'IPSL https.//www.ipsl.fr',
+    'Ocean'           : f'{dst_Name} https://www.nemo-ocean.eu',
+    'Atmosphere'      : f'{src_Name} http://lmdz.lmd.jussieu.fr',
+    'associatedFiles' : f'{grids} {areas} {masks}',
+    'description'     : 'Generated with XIOS http://forge.ipsl.jussieu.fr/ioserver and MOSAIX https://forge.ipsl.jussieu.fr/igcmg/browser/TOOLS/MOSAIX',
+    'title'           : calving,
+    'Program'         : f'Generated by {sys.argv[0]} with flags ' + ' '.join (sys.argv[1:]),
+    'repartitionType' : myargs.type,
+    'gridsFile'       : grids,
+    'areasFile'       : areas,
+    'masksFile'       : masks,
+    'timeStamp'       : time.asctime(),
+    'directory'       : os.getcwd (),
+    'HOSTNAME'        : platform.node (),
+    'LOGNAME'         : getpass.getuser(),
+    'Python'          : 'Python version ' +  platform.python_version (),
+    'OS'              : platform.system (),
+    'release'         : platform.release (),
+    'hardware'        : platform.machine (),
+    'conventions'     : 'SCRIP',
+    'dest_grid'       : 'curvilinear',
+    'Model'           : model_name,
+    'SVN_Author'      : '$Author$',
+    'SVN_Date'        : '$Date$',
+    'SVN_Revision'    : '$Revision$',
+    'SVN_Id'          : '$Id$',
+    'SVN_HeadURL'     : '$HeadURL$',
+    })
+
 if myargs.type in [ 'iceberg', 'iceshelf' ] :
-    f_calving.attrs['repartitionFile'] = myargs.repartition_file
-    f_calving.attrs['repartitionVar']  = repartitionVar
-f_calving.attrs['gridsFile']       = grids
-f_calving.attrs['areasFile']       = areas
-f_calving.attrs['masksFile']       = masks
-f_calving.attrs['timeStamp']       = time.asctime()
-try    : f_calving.attrs['directory'] = os.getcwd ()
-except : pass
-try    : f_runoff.attrs['HOSTNAME'] = platform.node ()
-except : pass
-try    : f_runoff.attrs['LOGNAME']  = os.getlogin ()
-except : pass
-try    : f_runoff.attrs['Python']   = "Python version " +  platform.python_version ()
-except : pass
-try    : f_runoff.attrs['OS']       = platform.system ()
-except : pass
-try    : f_runoff.attrs['release']  = platform.release ()
-except : pass
-try    : f_runoff.attrs['hardware'] = platform.machine ()
-except : pass
-f_calving.attrs['conventions']     = "SCRIP"
-if src_name == 'lmd' : f_calving.attrs['source_grid'] = "curvilinear"
-if src_name == 'ico' : f_calving.attrs['source_grid'] = "unstructured"
-f_calving.attrs['dest_grid']       = "curvilinear"
-f_calving.attrs['Model']           = "IPSL CM6"
-f_calving.attrs['SVN_Author']      = "$Author$"
-f_calving.attrs['SVN_Date']        = "$Date$"
-f_calving.attrs['SVN_Revision']    = "$Revision$"
-f_calving.attrs['SVN_Id']          = "$Id$"
-f_calving.attrs['SVN_HeadURL']     = "$HeadURL$"
+    f_calving.attrs.update ( {
+    'originalFiles'   : myargs.repartition_file,
+    'repartitionFile' : myargs.repartition_file,
+    'repartitionVar'  : repartitionVar,
+    } )
 
 ##
@@ -467,4 +553,4 @@
 f_calving.close()
 
-print ('That''s all folks !')
+print ("That''s all folks !")
 ## ======================================================================================
